﻿using Assets.Scripts.MapGeneration;
using Assets.Scripts.Utils;
using UnityEngine;
using System;

namespace Assets.Scripts
{
    internal class CADelegates
    {
        static System.Random r = new System.Random();

        public static bool CanGrow(Cell cell)
        {

            if (cell.Position.x == 0)
                return true;
            if (cell.Position.x % 10 == 0)
                return (cell.Position.y < 16 && (cell.Position.y * r.Next(100)) / 100
                        < 50);
            return false;
        }
    }

    public class GameController : MonoBehaviour
    {
        public static int PoolSize = 256;

        private Map _map;

        private ObjectPool _pooledWalls;
        private ObjectPool _pooledActors;
        private ObjectPool _pooledProjectiles;

        private CellularAutomaton _ca;

        void Start()
        {
            _map = new Map(128, 128);

            _pooledActors = new ObjectPool(PoolSize);
            _pooledProjectiles = new ObjectPool(PoolSize);
            _pooledWalls = new ObjectPool(PoolSize);

            _ca = new CellularAutomaton(_map, TileType.Wall);
            _ca.CanGrowRule = CADelegates.CanGrow;
        }

        void Update()
        {
            _ca.Step();
        }
    }
}